package Source::Package::Comparators;

use strict;
use warnings;
use Carp;
use RPM qw/evrcmp vercmp/;
use Source::Package::Comparators::Raw;

our $VERSION=0.001;
our $verbose=0;

sub null_comparator {
    my ($origin, $dest)=@_;
    return 0;
}

sub null_epoch_comparator {
    my ($origin, $dest)=@_;
    return 0;
}

sub generic_epoch_comparator {
    my ($origin, $dest)=@_;
    return $origin->epoch <=> $dest->epoch;
}

sub rpm40_epoch_comparator {
    my ($origin, $dest)=@_;
    return &__rpm40epoch($origin->epoch) <=> &__rpm40epoch($dest->epoch);
}

sub __rpm40epoch {
    return $_[0] ? $_[0]: 0;
}

sub pure_rpm_version_comparator {
    my ($origin, $dest)=@_;
    return vercmp($origin->version, 0, $dest->version, 0);
}

sub pure_rpm_release_comparator {
    my ($origin, $dest)=@_;
    return vercmp(0, $origin->release, 0, $dest->release);
}

sub null_release_comparator {
    my ($origin, $dest)=@_;
    return 0;
}

sub rpm_plus_perl_version_comparator {
    my ($origin, $dest)=@_;
    return &Source::Package::Comparators::Raw::_rpm_plus_perl_version_cmp(undef,$dest->name,$origin->version, $dest->version);
}

1;
